<?php
class Chat {
	const DB_FILE = "chat.db";
	const LIMIT   = 100;
	public function __construct(){
		/*各テーブル初期化
		$conn =  sqlite_open(self::DB_FILE);
   		$sql = "create table chat(id integer primary key,message text)";
   		sqlite_query($conn,$sql);
 		$sql = "create table users(id integer primary key,name text,atime integer)";
 		sqlite_query($conn,$sql);
    	sqlite_close($conn);
    	*/
   }
	//データ投入と同時に更新データ取得
	public function add($str){
		self::trace(self::getTime()." [".getenv('REMOTE_ADDR')."] message added:".$str);
    	$conn = sqlite_popen(self::DB_FILE);
		//最大保持件数を超えた場合削除
		if($this->getNumRows() >= self::LIMIT){
			$sql = "select min(id) as id from chat";
			$rs = sqlite_query($conn, $sql);
			$row = sqlite_fetch_array($rs,$SQLITE_ASSOC);
			$this->deleteRow($row['id']);
		}
		
		if(get_magic_quotes_gpc())
			$str = stripslashes($str);
		$str = sqlite_escape_string($str);
		$str = $str."  [".self::getTime()."]";
    	$sql = "insert into chat('message') values('$str')";
    	sqlite_query($conn,$sql) or die("no");
		sqlite_close($conn);
    	return $this->update();
   	}
   	//更新データ取得
	public function update(){
		$conn = sqlite_popen(self::DB_FILE);
   		$sql = "select * from chat order by id desc limit " .self::LIMIT;
    	$rs = sqlite_query($conn,$sql);
    	$arr = array();
    	while($row = sqlite_fetch_array($rs,SQLITE_ASSOC)){
      		array_push($arr,$row['message']."\n");
   	 	}
    	sqlite_close($conn);
    	return $arr;
	}
	//ユーザ名を挿入
	public function setUserId($name){
		self::trace(self::getTime()." [".getenv('REMOTE_ADDR')."] ".$name." Logged in");
		$conn = sqlite_popen(self::DB_FILE);
		if(get_magic_quotes_gpc())
			$name = stripslashes($name);
		$name = sqlite_escape_string($name);
		$atime = getdate();
    	$sql = "insert into users('name','atime') values('$name',$atime[0])";
    	sqlite_query($conn, $sql);
		sqlite_close($conn);
		return true;
	}
	//ログアウト時にユーザ名削除
	public function logout($name){
		self::trace(self::getTime()." [".getenv('REMOTE_ADDR')."] ".$name." Logged out");
		$conn = sqlite_popen(self::DB_FILE);
    	$sql = "delete from users where name = '$name'";
    	$rs = sqlite_query($conn, $sql);
		sqlite_close($conn);
		return $name;
	}
	//ログイン中のユーザ全員を検索
	public function getAllUsers($userName){
		$atime = getdate();
		$conn = sqlite_popen(self::DB_FILE);
		$sql = "update users set atime = ".$atime[0]." where name = '".$userName."'";
		sqlite_query($conn, $sql);
		$atime2 = $atime[0] - 30;
		$sql = "delete from users where atime < $atime2";
		sqlite_query($conn, $sql);
		$sql = "select name from users";
    	$rs = sqlite_query($conn, $sql);
    	$arr = array();
    	while($rows = sqlite_fetch_array($rs, SQLITE_ASSOC)){
    		array_push($arr, $rows['name']);
    	} 
		sqlite_close($conn);
		return $arr;
	}
	//行削除
 	private function deleteRow($id){
    	$conn 	= sqlite_open(self::DB_FILE);
    	$sql 	= "delete from chat where id = $id ";
    	sqlite_query($conn, $sql);
    	sqlite_close($conn);
    }
    //全ての行削除
 	private function deleteAllRows(){
    	$conn 	= sqlite_open(self::DB_FILE);
    	$sql 	= "delete from chat";
    	sqlite_query($conn, $sql);
    	$sql 	= "delete from users";
    	sqlite_query($conn, $sql);
    	sqlite_close($conn);
    }
     public function isExist($name){
     	if(get_magic_quotes_gpc())
			$name = stripslashes($name);
    	$conn 	= sqlite_open(self::DB_FILE);
    	$sql 	= "select *  from users where name = '$name'";
    	$rs = sqlite_query($conn, $sql);
  		$rows = sqlite_num_rows($rs);
    	sqlite_close($conn);
    	if($rows ==0){
    		return false;
    	}else{
    		return true;
    	}
    }
     private function getNumRows(){
    	$conn 	= sqlite_open(self::DB_FILE);
    	$sql 	= "select *  from chat";
    	$rs = sqlite_query($conn, $sql);
  		$rows = sqlite_num_rows($rs);
    	sqlite_close($conn);
    	return $rows;
    }
    //引数$strの内容をログファイルに出力
    //ログのファイル名はYYYYMMDDHH形式
   	static function trace($str){
   		$date = getdate();
   		$filename = "../../logs/".$date["year"].$date["mon"].$date["mday"].".log";
		try{
			$fp = fopen($filename, "a+");
			fwrite($fp, $str."\n");
			fclose($fp);
		}catch (Exception $e){
			
		}	
	}
	//ログファイル用の時間を出力
	static function getTime(){
		$date = getdate();
		return $date["year"]."年".$date["mon"]."月".$date["mday"]."日".$date["hours"]."時".$date["minutes"]."分";
	}
}
//$a = new Chat();
//$a->test();
//echo "create tbl ok";
?>